package com.yc.ship.module.resource.service.checkchannel;


import com.yc.ship.framework.common.pojo.PageResult;
import com.yc.ship.module.resource.controller.admin.checkchannel.vo.CheckChannelPageReqVO;
import com.yc.ship.module.resource.controller.admin.checkchannel.vo.CheckChannelRespVO;
import com.yc.ship.module.resource.controller.admin.checkchannel.vo.CheckChannelSaveReqVO;
import com.yc.ship.module.resource.dal.dataobject.checkchannel.CheckChannelDO;

import javax.validation.Valid;
import java.util.List;

/**
 * 产品检票通道 Service 接口
 *
 * @author 管理员
 */
public interface CheckChannelService {

    /**
     * 创建产品检票通道
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long create(@Valid CheckChannelSaveReqVO createReqVO);

    /**
     * 更新产品检票通道
     *
     * @param updateReqVO 更新信息
     */
    void update(@Valid CheckChannelSaveReqVO updateReqVO);

    /**
     * 删除产品检票通道
     *
     * @param id 编号
     */
    void delete(Long id);

    /**
     * 获得产品检票通道
     *
     * @param id 编号
     * @return 产品检票通道
     */
    CheckChannelDO getCheckChannel(Long id);

    /**
     * 获得产品检票通道分页
     *
     * @param pageReqVO 分页查询
     * @return 产品检票通道分页
     */
    PageResult<CheckChannelDO> getCheckChannelPage(CheckChannelPageReqVO pageReqVO);

    List<CheckChannelRespVO> getCheckChannelByBase(Long baseId);

    void deleteByProductId(Long productId);

    CheckChannelDO getCheckChannelByChannelAndProduct(Long productId, Long channelId);
}